/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <gtk/gtk.h>
#include "spinbuttons.h"
#include "powertweak.h"

void Change_SpinButton(GtkWidget __unused *widget, spinbuttons_t *spinbuttons)
{
	spinbuttons->current_value = gtk_spin_button_get_value_as_int
			(GTK_SPIN_BUTTON(spinbuttons->widget));
}


void CreateSpinButton(spinbuttons_t *spinbuttons, GtkWidget *table, int column)
{
	GtkWidget *hbox;
	GtkWidget *label;
	GtkWidget *spinbutton;
	GtkAdjustment *adj;

	hbox = gtk_hbox_new(TRUE, 0);
	label = gtk_label_new (spinbuttons->labelname);
	gtk_misc_set_alignment (GTK_MISC(label), 0, 0.5);
	gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);

	adj = (GtkAdjustment *) gtk_adjustment_new(
		spinbuttons->current_value,
		spinbuttons->low_limit, spinbuttons->high_limit,
		1.0, 16.0, 0.0 );
	spinbutton = gtk_spin_button_new (adj, 0, 0);
	spinbuttons->widget = spinbutton;

	gtk_spin_button_set_value (GTK_SPIN_BUTTON(spinbutton), spinbuttons->current_value);
	gtk_signal_connect (GTK_OBJECT(adj), "value_changed",
						GTK_SIGNAL_FUNC (Change_SpinButton),
						spinbuttons);

	gtk_widget_set_usize (spinbutton, 100, 0);
	gtk_box_pack_start (GTK_BOX(hbox), spinbutton, FALSE, FALSE, 0);
	gtk_table_attach(GTK_TABLE(table), hbox, 0, 1, column, column+1,
					GTK_FILL|GTK_EXPAND, 0, 5, 5);

	gtk_widget_show(label);
	gtk_widget_show(spinbutton);
	gtk_widget_show(hbox);
}
