/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "tickbuttons.h"
#include "pciutils.h"
#include "../hardware/PCI/tweak.h"
#include "powertweak.h"

extern void modify_tweak_info (GtkWidget *, const char *);

void toggle_tick (GtkWidget __unused *widget, char *value)
{
	if (*value)
		*value=0;
	else
		*value=1;
}


GtkWidget *CreateTick(const char *label, char *description, GtkWidget *table, int column, char defaultvalue,
					char *currentstateptr)
{
	GtkWidget *tickbutton;

	tickbutton = gtk_check_button_new_with_label (label);

	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tickbutton), defaultvalue); 

	gtk_table_attach(GTK_TABLE(table), tickbutton, 0, 1, column, column+1,
					GTK_FILL|GTK_EXPAND, 0, 5, 5);

	gtk_signal_connect (GTK_OBJECT (tickbutton), "clicked", GTK_SIGNAL_FUNC (toggle_tick), currentstateptr);
	gtk_signal_connect (GTK_OBJECT (tickbutton), "enter", GTK_SIGNAL_FUNC (modify_tweak_info), description);
	gtk_widget_show(tickbutton);

	return (tickbutton);
}


void Create_PCI_TickButton (GtkWidget *table, Tweaks_t *tweaks, struct pci_dev *current_dev, int column)
{
	if ((pci_read_byte (current_dev, tweaks->reg) & tweaks->mask) == tweaks->value)
		tweaks->original_value=TRUE;
	else
		tweaks->original_value=FALSE;
	tweaks->current_value=tweaks->original_value;

	tweaks->widget = CreateTick (tweaks->name,
								tweaks->description,
								table, column,
								tweaks->current_value,
								&tweaks->current_value );
}


void Create_Proc_TickButton(tickbuttons_t *tickbuttons, GtkWidget *table, int column)
{
	tickbuttons->current_value = tickbuttons->current_value;
	tickbuttons->widget = CreateTick (tickbuttons->labelname,
									tickbuttons->description,
									table, column,
									tickbuttons->current_value,
									&tickbuttons->current_value );
}
