/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "../../ctree.h"

#include "cpudata.h"

//FIXME: Make this SMP compliant.
// Needs to find the number of CPUs (Without using /proc/cpuinfo)
// and also run 'cpuid()' on a specific CPU.

/* Create_CPU_SubTree */
void Create_CPU_SubTree(GtkCTree* tree, GtkCTreeNode* parent)
{
	GtkCTreeNode* item_new;
	char CPUNameString[16];
	gchar Array[128];
	gchar *Buffer[1];
	struct CPU_treenode *dataptr;
	int Number_of_CPUs=1, i;
	unsigned long eax, ebx, ecx, edx;

	Buffer[0] = Array;

	/* Populate the CPU tree. */
	for (i=0; i<Number_of_CPUs; i++) {

		cpuid(0, &eax, &ebx, &ecx, &edx);
		regprint (CPUNameString, ebx);
		regprint (CPUNameString+4, edx);
		regprint (CPUNameString+8, ecx);

		sprintf(Buffer[0], "CPU %d : %s", i, CPUNameString);

		item_new = gtk_ctree_insert_node (tree, parent, NULL, Buffer, 0,
						NULL, NULL, NULL, NULL, TRUE, FALSE);

		//FIXME: The following malloc is never freed.
		//FIXME: If the following malloc fails, the nodes that succeeded are not freed.
		dataptr = malloc (sizeof (struct CPU_treenode));
		if (dataptr == NULL) {
			printf ("Can't malloc memory for node!\n");
		} else {
			dataptr->node_type = node_CPU;
			gtk_ctree_node_set_row_data (tree, item_new, dataptr);
		}
	}
}
