/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <gtk/gtk.h>
#include "cpudata.h"
#include "../../notebook.h"

extern void identify_CPU(void);

extern void show_CPU_info_AMD(void);
extern void show_CPU_info_CYRIX(void);
extern void show_CPU_info_IDT(void);
extern void show_CPU_info_Intel(void);
extern void show_CPU_info_generic(void);

extern struct cpudata cpu0_data;
extern GtkText *TweakInfoTextPtr;

void select_CPU_item(void)
{
	remove_all_pages(notebook);
	TweakInfoTextPtr=NULL;

	identify_CPU();

	switch (cpu0_data.vendor) {
		case CPU_VENDOR_AMD:
			show_CPU_info_AMD();
			break;

		case CPU_VENDOR_CYRIX:
			show_CPU_info_CYRIX();
			break;

		case CPU_VENDOR_IDT:
			show_CPU_info_IDT();
			break;

		case CPU_VENDOR_INTEL:
			show_CPU_info_Intel();
			break;

		default:
			show_CPU_info_generic();
			break;
	}
}
