/*
 * Hardware tuning for the AMD 751 System cotroller
 */

#include <stdio.h>
#include "pciutils.h"
#include "../tweak.h"
#include "751.h"
#include "powertweak.h"

#define AMD_751_TWEAKSIZE (sizeof(AMD_751_Tweaks)/sizeof(Tweaks_t))-1


unsigned int getnumtweaks_AMD_751(struct pci_dev __unused *current_dev)
{
	return AMD_751_TWEAKSIZE;
}

void init_AMD_751(struct pci_dev *current_dev)
{
	init_tweaks(AMD_751_TWEAKSIZE, AMD_751_Tweaks, current_dev);
}

void tune_AMD_751(GtkWidget *table, struct pci_dev *current_dev, unsigned int numbuttons)
{
	Tweaks_t *Tweaks;

	unsigned int index;
	int column=0;

	Tweaks = AMD_751_Tweaks;

	for (index=0;index<numbuttons;index++) {
		Create_PCI_TickButton(table, Tweaks, current_dev, column);
		column++;
		Tweaks++;
	}
}

void save_AMD_751(FILE *savehandle, struct pci_dev *current_dev)
{
	write_tweaks(savehandle, AMD_751_TWEAKSIZE, AMD_751_Tweaks, current_dev);
}
