/*
 * Hardware tuning for the AMD 751 System Controller.
 */

#define PCI_DEVICE_ID_AMD_751 0x7006

static Tweaks_t AMD_751_Tweaks[] = {
	{ 0, "SDRAM_ADDRB_DRV",
		0x54,
		(1<<23)|(1<<22),
		(1<<23)|(1<<22),
		"SDRAM AddrB drv ClkOut Drv",
		"11",
		0, 0 },

	{ 0, "SDRAM_ADDRA_DRV",
		0x54,
		(1<<21)|(1<<20),
		(1<<21)|(1<<20),
		"SDRAM AddrA drv",
		"11",
		0, 0 },

	{ 0, "SDRAM_CAS_RAS_WE_CKE_CS",
		0x54,
		(1<<19)|(1<<18),
		(1<<19)|(1<<18),
		"SDRAM CAS[2:0] RAS[2:0] WE[2:0] CKE[2:0] CS[5:0] drive",
		"11",
		0, 0 },

	{ 0, "SDRAM_DQM_DRV",
		0x54,
		(1<<17)|(1<<16),
		(1<<17)|(1<<16),
		"SDRAM DQM drive",
		"11",
		0, 0 },

	{ 0, "CAS_LATENCY",
		0x54,
		(1<<3)|(1<<2),
		(1<<2),
		"Tcl (Cas Latency)",
		"01",
		0, 0 },

	{ 0, "RAS_LATENCY",
		0x54,
		(1<<3)|(1<<2),
		0,
		"Trcd (Ras Latency)",
		"11",
		0, 0 },

	{ 0, "BURST_REFRESH",
		0x58,
		(1<<20),
		(1<<20),
		"Burst Refresh",
		"1",
		0, 0 },

	{ 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};
