/*
 * Hardware tuning for the Intel 8243x PCI bridges.
 * This covers..
 *	82437FX TSC [Triton I]
 *	82439HX TXC [Triton II]
 *	82439TX MTXC
 */

#define PCI_DEVICE_ID_Intel_82437FX 0x122d	/* FX */
#define PCI_DEVICE_ID_Intel_82439HX 0x1250	/* HX */

static Tweaks_t Intel_8243x_Tweaks[] = {
	{ 0, "PCI_CONCURRENCY",
		0x50,
		1<<3,
		1<<3,
		"PCI concurrency",
		"CPU can access DRAM and L2 while a non-PIIX3 PCI master is targetting peer PCI devices",
		0, 0 },

	{ 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};
