/*
 Matrox video BIOS area decoding routines.
 
 (C) 2000 Dave Jones.

*/

#include <string.h>
#include <stdio.h>

/*******************************************
 Decode BIOS area
 *******************************************/
int decode_biosarea(char **TextPtr, char *memptr)
{
	int i=0;
	unsigned short pinsoffset;
	short subsys_vendor;
	char *LSIptr;
	unsigned char option;
	static char LSIstring[]= "Copyright (C) LSI Logic Corporation 1990-1991\r\n\r\n\0";

	*TextPtr+=sprintf(*TextPtr, "BIOS filename\t: %s\n", &memptr[0x78]);

	/* Garg, another bug.
	   Seems that this field isn't always stored at 0x7ff0.
	   To get around this, we must use the official method of sizing VRAM,
	   which is to call Int 10h AX=4f14 BL=0, ES:DI=256 byte buffer.
	   Offset 2b-2c == Video ram in 64Kb units. I'll do this in some future version. */
	//printf("Video ram\t: %dMb.\n", memptr[0x7ff0]);

	subsys_vendor = (memptr[0x7ff8] & 0x00ff) | (memptr[0x7ff9]<<8);
	*TextPtr+=sprintf(*TextPtr, "SUBSYS_VID\t: ");
	switch (subsys_vendor) {
	    case 0x102b :	*TextPtr+=sprintf(*TextPtr, "Matrox Graphics Inc.\n");
						break;
	    case 0x1014 :	*TextPtr+=sprintf(*TextPtr, "IBM.\n");
						break;
	    case 0x110A :	*TextPtr+=sprintf(*TextPtr, "Siemens.\n");
						break;
	    default	:		*TextPtr+=sprintf(*TextPtr, "%x Unknown vendor! Inform author.\n", subsys_vendor);
						break;
	}

	*TextPtr+=sprintf(*TextPtr, "Hardware rev\t: %x\n", memptr[0x7ffa]);

	pinsoffset = (memptr[0x7FFC] & 0x00ff) | (memptr[0x7FFD]<<8);

//FIXME: The following snippet of code segfaults...
/*	printf ("\tBIOS Checksum\t: %x (", memptr[0x7fff]);
	for (i=0; i<memptr[pinsoffset+2]; i++) {
	    checksum += memptr[pinsoffset + i];
	}
	if (checksum%256)
		TextPtr+=sprintf (TextPtr, "in");
	TextPtr+=sprintf (TextPtr, "valid)\n");
*/
	LSIptr = LSIstring;
	for (i=0; i<0x7fff ; i++) {
	    if (strncmp (&memptr[i], LSIptr, strlen(LSIstring)) == 0) {
			option = memptr[i + strlen(LSIstring)];
			*TextPtr+=sprintf(*TextPtr, "Option byte\t: %x (Signon message %s)\n",
				option, ((option & 1) ? "enabled" : "disabled"));
			break;
	    }
	}
	return (pinsoffset);
}
