/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdio.h>
#include <gtk/gtk.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>
#include "pciutils.h"
#include "../../../notebook.h"
#include "scan-lfb.h"
#include "Matrox.h"

#define VIDEO_BIOS_START 0x000C0000L
#define VIDEO_BIOS_END   0x000C8000L
#define VIDEO_BIOS_SIZE VIDEO_BIOS_END-VIDEO_BIOS_START

int getLFB(LFB lfb[], struct pci_dev *dev);


int handle_matrox_cards (GtkWidget *notebook, struct pci_dev *current_pci_dev)
{
	char TextBuffer[2048];
	char *TextPtr;
	char *p;
	GtkText *InfoTextPtr;
	LFB LFB_table[5];
	long fp;
	int pinsoffset;
	int fd, i;
	int num_of_LFBs;
	char return_value=0;

	TextPtr=TextBuffer;

	/* Read data from the video BIOS. */
	fd=open("/dev/mem", O_RDONLY);
	fp=VIDEO_BIOS_START;

	if(fd==-1) {
		TextPtr+=sprintf (TextPtr, "Problems opening /dev/mem\n");
	} else {

		p = mmap (NULL, VIDEO_BIOS_SIZE, PROT_READ, MAP_SHARED, fd, VIDEO_BIOS_START);

		if (p == (void *)-1) {
			TextPtr+=sprintf (TextPtr, "Problems mapping BIOS.\n");
		} else {
	
			pinsoffset = decode_biosarea(&TextPtr, p);
			decode_pins(&TextPtr, pinsoffset, p);

			num_of_LFBs = getLFB(LFB_table, current_pci_dev);
			if (num_of_LFBs!=0) {
				TextPtr+=sprintf (TextPtr, "Found %d LFBs\n", num_of_LFBs);
				for (i=0;i<num_of_LFBs;i++)
					TextPtr+=sprintf(TextPtr, "\tbase:%lx\tmask:%lx\n", LFB_table[0].base, LFB_table[0].mask);
			}
			munmap (p, VIDEO_BIOS_SIZE);
			return_value = 1;
		}
		close(fd);
	}

	AddPage (GTK_NOTEBOOK(notebook), "Extended info");
	InfoTextPtr = (GTK_TEXT(CreateText(TextBuffer)));
	gtk_container_add (GTK_CONTAINER (current_pages[current_max_page-1]), GTK_WIDGET(InfoTextPtr));
	return(return_value);
}
