/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include "pciutils.h"
#include "../../ctree.h"

extern struct pci_access *pacc;

/* Create_PCI_SubTree */
void Create_PCI_SubTree(GtkCTree* tree, GtkCTreeNode* parent)
{
	GtkCTreeNode* item_new;
	char namebuf[256];
	gchar Array[256];
	gchar *Buffer[1];
	struct PCI_treenode *dataptr;
	struct pci_dev *dev;
	
	Buffer[0] = Array;

	dev = pacc->devices;
	
	/* Populate the PCI tree. */
	while (dev) {

		sprintf(Buffer[0], "%s",
			pci_lookup_name(pacc, namebuf, sizeof(namebuf),
				PCI_LOOKUP_VENDOR|PCI_LOOKUP_DEVICE,
				dev->vendor_id, dev->device_id, 0, 0));

		item_new = gtk_ctree_insert_node (tree, parent, NULL, Buffer, 0,
						NULL, NULL, NULL, NULL, TRUE, FALSE);

		//FIXME: The following malloc is never freed.
		//FIXME: If the following malloc fails, the nodes that succeed are not freed.
		dataptr = malloc (sizeof (struct PCI_treenode));
		if (dataptr == NULL) {
			printf ("Can't malloc memory for node!\n");
		} else {
			dataptr->node_type = node_PCI;
			dataptr->node_data = dev;
			gtk_ctree_node_set_row_data_full (tree, item_new, dataptr, free_dataptr);
		}
		dev = dev->next;
	}
}
