/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdlib.h>

#include "pciutils.h"
#include "Matrox/Matrox.h"
#include "known-PCI.h"
#include "../../create-GUI.h"
#include "../../notebook.h"

extern GtkText *TweakInfoTextPtr;

extern unsigned int getnumtweaks_AMD_751(struct pci_dev *);
extern void init_AMD_751(struct pci_dev *);
extern void tune_AMD_751(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_AMD_751(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_DEC_21050(struct pci_dev *);
extern void init_DEC_21050(struct pci_dev *);
extern void tune_DEC_21050(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_DEC_21050(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_Intel_824xx(struct pci_dev *);
extern void init_Intel_824xx(struct pci_dev *);
extern void tune_Intel_824xx(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_Intel_824xx(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_Intel_824xx(struct pci_dev *);
extern void init_Intel_824xx(struct pci_dev *);
extern void tune_Intel_824xx(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_Intel_824xx(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_Intel_824xx(struct pci_dev *);
extern void init_Intel_824xx(struct pci_dev *);
extern void tune_Intel_824xx(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_Intel_824xx(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_Intel_8243x(struct pci_dev *);
extern void init_Intel_8243x(struct pci_dev *);
extern void tune_Intel_8243x(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_Intel_8243x(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_Intel_8243x(struct pci_dev *);
extern void init_Intel_8243x(struct pci_dev *);
extern void tune_Intel_8243x(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_Intel_8243x(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_Intel_82437VX(struct pci_dev *);
extern void init_Intel_82437VX(struct pci_dev *);
extern void tune_Intel_82437VX(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_Intel_82437VX(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_Intel_82439TX(struct pci_dev *);
extern void init_Intel_82439TX(struct pci_dev *);
extern void tune_Intel_82439TX(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_Intel_82439TX(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_Intel_82443LX(struct pci_dev *);
extern void init_Intel_82443LX(struct pci_dev *);
extern void tune_Intel_82443LX(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_Intel_82443LX(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_Intel_82443BX(struct pci_dev *);
extern void init_Intel_82443BX(struct pci_dev *);
extern void tune_Intel_82443BX(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_Intel_82443BX(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_Intel_82443BX(struct pci_dev *);
extern void init_Intel_82443BX(struct pci_dev *);
extern void tune_Intel_82443BX(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_Intel_82443BX(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_VIA_586_0(struct pci_dev *);
extern void init_VIA_586_0(struct pci_dev *);
extern void tune_VIA_586_0(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_VIA_586_0(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_VIA_586_1(struct pci_dev *);
extern void init_VIA_586_1(struct pci_dev *);
extern void tune_VIA_586_1(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_VIA_586_1(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_VIA_597_0(struct pci_dev *);
extern void init_VIA_597_0(struct pci_dev *);
extern void tune_VIA_597_0(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_VIA_597_0(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_VIA_597_1(struct pci_dev *);
extern void init_VIA_597_1(struct pci_dev *);
extern void tune_VIA_597_1(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_VIA_597_1(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_VIA_598_1(struct pci_dev *);
extern void init_VIA_598_1(struct pci_dev *);
extern void tune_VIA_598_1(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_VIA_598_1(FILE *, struct pci_dev *);
extern unsigned int getnumtweaks_UMC_8891A(struct pci_dev *);
extern void init_UMC_8891A(struct pci_dev *);
extern void tune_UMC_8891A(GtkWidget *, struct pci_dev *, unsigned int);
extern void save_UMC_8891A(FILE *, struct pci_dev *);

extern int handle_matrox_cards(GtkWidget *, struct pci_dev *);
extern Known_Card_t known_matrox_cards[];

devinfo_t known_devlist[] = {

 { PCI_VENDOR_ID_AMD, PCI_DEVICE_ID_AMD_751, 0,
		NULL,
		getnumtweaks_AMD_751,
		init_AMD_751,
		tune_AMD_751,
		save_AMD_751 },

 { PCI_VENDOR_ID_DEC, PCI_DEVICE_ID_DEC_21050, 0,
		NULL,
		getnumtweaks_DEC_21050,
		init_DEC_21050,
		tune_DEC_21050,
		save_DEC_21050 },

 { PCI_VENDOR_ID_INTEL,	PCI_DEVICE_ID_Intel_82424, 0,
		NULL,
		getnumtweaks_Intel_824xx,
		init_Intel_824xx,
		tune_Intel_824xx,
		save_Intel_824xx },

 { PCI_VENDOR_ID_INTEL,	PCI_DEVICE_ID_Intel_82430, 0,
		NULL,
		getnumtweaks_Intel_824xx,
		init_Intel_824xx,
		tune_Intel_824xx,
		save_Intel_824xx },

 { PCI_VENDOR_ID_INTEL,	PCI_DEVICE_ID_Intel_82434, 0,
		NULL,
		getnumtweaks_Intel_824xx,
		init_Intel_824xx,
		tune_Intel_824xx,
		save_Intel_824xx },

 { PCI_VENDOR_ID_INTEL,	PCI_DEVICE_ID_Intel_82437FX, 0,
		NULL,
		getnumtweaks_Intel_8243x,
		init_Intel_8243x,
		tune_Intel_8243x,
 		save_Intel_8243x },

 { PCI_VENDOR_ID_INTEL,	PCI_DEVICE_ID_Intel_82439HX, 0,
		NULL,
		getnumtweaks_Intel_8243x,
		init_Intel_8243x,
		tune_Intel_8243x,
 		save_Intel_8243x },

 { PCI_VENDOR_ID_INTEL,	PCI_DEVICE_ID_Intel_82437VX, 0,
		NULL,
		getnumtweaks_Intel_82437VX,
		init_Intel_82437VX,
		tune_Intel_82437VX,
 		save_Intel_82437VX },

 { PCI_VENDOR_ID_INTEL,	PCI_DEVICE_ID_Intel_82439TX, 0,
		NULL,
		getnumtweaks_Intel_82439TX,
		init_Intel_82439TX,
		tune_Intel_82439TX,
		save_Intel_82439TX },

 { PCI_VENDOR_ID_INTEL,	PCI_DEVICE_ID_Intel_82443LX, 0,
		NULL,
		getnumtweaks_Intel_82443LX,
		init_Intel_82443LX,
		tune_Intel_82443LX,
		save_Intel_82443LX },

 { PCI_VENDOR_ID_INTEL,	PCI_DEVICE_ID_Intel_82443BX, 0,
		NULL,
		getnumtweaks_Intel_82443BX,
		init_Intel_82443BX,
		tune_Intel_82443BX,
 		save_Intel_82443BX },

// FIXME: The BX entries should use a knownlist.
 { PCI_VENDOR_ID_INTEL,	PCI_DEVICE_ID_Intel_82443BX_NOAGP, 0,
		NULL,
		getnumtweaks_Intel_82443BX,
		init_Intel_82443BX,
		tune_Intel_82443BX,
 		save_Intel_82443BX },

 { PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_586_0, 0,
		NULL,
		getnumtweaks_VIA_586_0,
		init_VIA_586_0,
		tune_VIA_586_0,
 		save_VIA_586_0 },

 { PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_586_1, 0,
		NULL,
		getnumtweaks_VIA_586_1,
		init_VIA_586_1,
		tune_VIA_586_1,
		save_VIA_586_1 },

 { PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_597_0, 0,
		NULL,
		getnumtweaks_VIA_597_0,
		init_VIA_597_0,
		tune_VIA_597_0,
 		save_VIA_597_0 },

 { PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_597_1, 0,
		NULL,
		getnumtweaks_VIA_597_1,
		init_VIA_597_1,
		tune_VIA_597_1,
 		save_VIA_597_1 },

 { PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_598_1, 0,
		NULL,
		getnumtweaks_VIA_598_1,
		init_VIA_598_1,
		tune_VIA_598_1,
 		save_VIA_598_1 },

 { PCI_VENDOR_ID_UMC, PCI_DEVICE_ID_UMC_8891A, 0,
		NULL,
		getnumtweaks_UMC_8891A,
		init_UMC_8891A,
		tune_UMC_8891A,
 		save_UMC_8891A },

 { PCI_VENDOR_ID_MATROX, NUM_KNOWN_MATROX_CARDS,
		known_matrox_cards,
		handle_matrox_cards,
		0,
		0,
		0,
		0 },

 { 0, 0, 0, 0, 0, 0, 0, 0 }
};

//FIXME: Use sizeof and a #define instead of null-termination
void create_known_device (devinfo_t *devinfo, struct pci_dev *current_pci_dev)
{
	unsigned int num_widgets;
	GtkWidget *scrolled_win;
	GtkWidget *table;
	GtkWidget *vbox;

	/* Can we extract any interesting info from this device ? */
	if (devinfo->extended_info)
		devinfo->extended_info (notebook, current_pci_dev);

	/* Is this device tweakable ? */
	if (devinfo->gadget_counter) {

		num_widgets = devinfo->gadget_counter(current_pci_dev);

		scrolled_win = gtk_scrolled_window_new (NULL, NULL);
		gtk_widget_set_usize (scrolled_win, (WindowWidth/3)*2, 260);
		gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (scrolled_win),
										GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

		table = gtk_table_new (num_widgets, 1, TRUE);
		devinfo->gadget_adder(table, current_pci_dev, num_widgets);

		gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_win), table);

		gtk_widget_show (table);
		gtk_widget_show (scrolled_win);

		AddPage (GTK_NOTEBOOK(notebook), "Tweaks");
		TweakInfoTextPtr = (GTK_TEXT(CreateText("")));

		vbox = gtk_vbox_new (FALSE, 0);
		gtk_box_pack_start (GTK_BOX (vbox), scrolled_win, TRUE, TRUE, 0);
		gtk_box_pack_start (GTK_BOX (vbox), GTK_WIDGET(TweakInfoTextPtr), TRUE, TRUE, 0);
		gtk_widget_show (vbox);
		gtk_container_add (GTK_CONTAINER (current_pages[current_max_page-1]), vbox);
	}
}
