/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>

#include "pciutils.h"

typedef struct Tweaks_s {
	GtkWidget	*widget;
	const char	*tagname;		/* What we look for in the config file*/
	const int	reg;			/* Register */
	const int	mask;			/* Used to mask out the bits we want */
	const int	value;			/* What to put in reg */
	const char	*name;			/* Widget name */
	char		*description;	/* Description of what tweak does */
	char		original_value;	/* RESERVED, define as 0 */
	char		current_value;	/* RESERVED, define as 0 */
} Tweaks_t;

void init_tweaks(unsigned int numtweaks, Tweaks_t *tweaks, struct pci_dev *current_dev);
void write_tweaks(FILE *savehandle,
				unsigned int numtweaks,
				Tweaks_t *tweaks,
				struct pci_dev *current_dev);
				
void Create_PCI_TickButton (GtkWidget *table, Tweaks_t *tweaks, struct pci_dev *current_dev, int column);
