/*
 * Copyright (c) 2000 Dave Jones <dave@powertweak.com>
 *
 * Can be freely distributed and used under the terms of the GNU GPL.
 */

#include <stdio.h>
#include <stdlib.h>
#include "pciutils.h"
#include "known-PCI.h"
#include "powertweak.h"

extern devinfo_t known_devlist;

int card_known (unsigned int num, Known_Card_t *known_cards, unsigned short device_id)
{
	unsigned int i;

	for (i=0;i<num;i++) {
		if (device_id == known_cards->device) {
			return (TRUE);
		}
		else
			known_cards++;
	}
	return (FALSE);
}


void create_known_device (devinfo_t *devinfo, struct pci_dev *current_pci_dev)
{
	unsigned int num_widgets;

	/* Is this device tweakable ? */
	if (devinfo->gadget_counter) {
		num_widgets = devinfo->gadget_counter(current_pci_dev);
		devinfo->gadget_adder(current_pci_dev, num_widgets);
	}
}


void select_PCI_item(struct pci_access *pacc, struct pci_dev *current_pci_dev)
{
//	char namebuf[256];
//	char TextBuffer[2048];
//	char *TextPtr;
	struct devinfo_s *current_devinfo;
/*
	TextPtr=TextBuffer;

	TextPtr+=sprintf(TextPtr, "\nVendor: %.4x (%s)\nDevice: %.4x (%s)\nClass: %s\n",
		current_pci_dev->vendor_id,
		pci_lookup_name(pacc, namebuf, sizeof(namebuf),
			PCI_LOOKUP_VENDOR,
			current_pci_dev->vendor_id, 0, 0, 0),
		current_pci_dev->device_id,
		pci_lookup_name(pacc, namebuf, sizeof(namebuf),
			PCI_LOOKUP_DEVICE,
			current_pci_dev->vendor_id,
			current_pci_dev->device_id, 0, 0),
		pci_lookup_name(pacc, namebuf, sizeof(namebuf),
			PCI_LOOKUP_CLASS,
			(pci_read_word (current_pci_dev, PCI_CLASS_DEVICE)),
			0,0,0));
*/

	/* If we know any tweaks for this device, we add an extra tab. */
	current_devinfo = &known_devlist;

	while (current_devinfo->vendor) {

		if (current_devinfo->vendor != current_pci_dev->vendor_id)
			goto next_device;

		/* Do we know anything about this device ? */
		if (current_devinfo->device == current_pci_dev->device_id) {
			create_known_device (current_devinfo, current_pci_dev);
			goto done_device;
		}

		if (current_devinfo->known_cards) {
			if (card_known(current_devinfo->device,
							 current_devinfo->known_cards,
							 current_pci_dev->device_id)==TRUE) {
				create_known_device (current_devinfo, current_pci_dev);
			}
		}

next_device:
		current_devinfo++;
	}
done_device:
}
