/*
 *  dialog - Display simple dialog boxes from shell scripts
 *
 *  ORIGINAL AUTHOR: Savio Lam (lam836@cs.cuhk.hk)
 *  MODIFIED FOR LINUX KERNEL CONFIG BY: William Roadcap (roadcap@cfw.com)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define FALSE 0
#define TRUE 1

#define NUM_MAIN_OPTIONS 4
#define OPTION_PCI 0
#define OPTION_FS 1
#define OPTION_NET 2
#define OPTION_VM 3

#define OPTION_CHOSEN 0

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include "dialog.h"
#include "pciutils.h"
/* #include "PCI/gui.c" */

int show_PCI_devices(void);

int main (void)
{
	const char title[]="Powertweak";
	const char prompt[]="Choose performance area to tune.";
	const char *titleptr=title;
	const char *promptptr=prompt;
	
	const char *items[]={
		"1", "PCI Devices",
		"2", "Filesystem",
		"3", "Networking",
		"4", "Virtual Memory",
	};
	const char *currentptr=items[0];
	int height=20;
	int width=60;
	int retval;
	unsigned int chosen_option;

redisplay:
	init_dialog();
	retval = dialog_menu (titleptr, promptptr, height, width, height-10, currentptr, NUM_MAIN_OPTIONS, FALSE, items, &chosen_option);
	end_dialog();

	if (retval==OPTION_CHOSEN) {
	
		switch (chosen_option) {
			case OPTION_PCI:
				show_PCI_devices();
				goto redisplay; 

			case OPTION_FS:
				printf("Show FS GUI\n");
				break;

			case OPTION_NET:
				printf("Show NET GUI\n");
				break;

			case OPTION_VM:
				printf("Show VM GUI\n");
				break;
			default:
				printf ("option=%d\n", chosen_option);
				break;
		}
	}

	exit (0);
}
